{% extends 'base_front.html.twig' %}
{% block title %}<title>Recharge cagnotte</title>{% endblock %}

{% block section %}
    <div class="container" style="display:flex; align-items:center; justify-content: center;">
     <!-- Display a payment form -->
    <form id="payment-form" class="payment-form" action="{{ path("app_subscription") }}" method="POST">
      <div id="payment-element">
        <!--Stripe.js injects the Payment Element-->
      </div>

      <!-- We'll put the error messages in this element -->
        <div id="messages" role="alert"></div>

      <button style="width: 40%;" id="submit" type="submit" class="btn-wallet">
        <div class="spinner hidden" id="spinner"></div>
        <span id="button-text">Payer {{amount_final}} €</span>
      </button>
      <div id="payment-message" class="hidden"></div>
    </form>

    <script src="https://js.stripe.com/v3/"></script>

    <script>
      // This is your test publishable API key.
      var stripeToken = '{{ stripePubKey }}';
      const stripe = Stripe(stripeToken);

      const clientSecret = '{{ intentSecret }}';

      let elements;
      elements = stripe.elements({ clientSecret });

      var cardHolderEmail= '{{ app.user.email }}';
      var cardHolderName = '{{ app.user.lastname }}';

      document
        .querySelector("#payment-form")
        document.addEventListener("submit", handleSubmit);

      const paymentElement = elements.create("payment");
      paymentElement.mount("#payment-element");

      async function handleSubmit(e) {
        e.preventDefault();
        setLoading(true);

        const {error}  = await stripe.confirmPayment({
          elements,
          confirmParams: {
          // Make sure to change this to your payment completion page
          return_url: "https://anybet.ovh/souscription" //Routing.generate('app_subscription', [], true)

          }
        });

        setLoading(false);
      }

      function stripeTokenHandler(intent) {
            var form = document
            .querySelector("#payment-form");
            var inputIntentId = document.createElement('input');
            inputIntentId.setAttribute('type', 'hidden');
            inputIntentId.setAttribute('name', 'stripeIntentId'); 
            inputIntentId.setAttribute('value', intent.id);
            form.appendChild(inputIntentId);
            form.submit();    
      }

      // ------- UI helpers -------

      function showMessage(messageText) {
        const messageContainer = document.querySelector("#payment-message");

        messageContainer.classList.remove("hidden");
        messageContainer.textContent = messageText;

        setTimeout(function () {
          messageContainer.classList.add("hidden");
          messageText.textContent = "";
        }, 4000);
      }

      // Show a spinner on payment submission
      function setLoading(isLoading) {
        if (isLoading) {
          // Disable the button and show a spinner
          document.querySelector("#submit").disabled = true;
          document.querySelector("#spinner").classList.remove("hidden");
          document.querySelector("#button-text").classList.add("hidden");
        } else {
          document.querySelector("#submit").disabled = false;
          document.querySelector("#spinner").classList.add("hidden");
          document.querySelector("#button-text").classList.remove("hidden");
        }
      }

    </script>
{% endblock %}
